Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.optim
Class BaseMultiStartMultivariateOptimizer<PAIR>

    java.lang.Object
      org.apache.commons.math3.optim.BaseOptimizer<PAIR>
          org.apache.commons.math3.optim.BaseMultivariateOptimizer<PAIR>
              org.apache.commons.math3.optim.BaseMultiStartMultivariateOptimizer<PAIR>

Type Parameters:
  `PAIR` - Type of the point/value pair returned by the optimization algorithm.

Direct Known Subclasses:
  MultiStartMultivariateOptimizer, MultiStartMultivariateVectorOptimizer

    public abstract class BaseMultiStartMultivariateOptimizer<PAIR>

extends BaseMultivariateOptimizer<PAIR>

Base class multi-start optimizer for a multivariate function.
This class wraps an optimizer in order to use it several times in turn with different starting points (trying to avoid being trapped in a local extremum when looking for a global one). It is not a "user" class.

Since:
  3.0
Version:
  $Id$

Field Summary

Fields inherited from class org.apache.commons.math3.optim.BaseOptimizer
`evaluations, iterations`

Constructor Summary
`BaseMultiStartMultivariateOptimizer(BaseMultivariateOptimizer<PAIR> optimizer, int starts, RandomVectorGenerator generator)` Create a multi-start optimizer from a single-start optimizer.

Method Summary
`protected abstract void` | `clear()` Method that will called in order to clear all stored optima.
`protected PAIR` | `doOptimize()` Performs the bulk of the optimization algorithm.
`int` | `getEvaluations()` Gets the number of evaluations of the objective function.
`abstract PAIR[]` | `getOptima()` Gets all the optima found during the last call to `optimize`.
`PAIR` | `optimize(OptimizationData... optData)` Stores data and performs the optimization.
`protected abstract void` | `store(PAIR optimum)` Method that will be called in order to store each found optimum.

Methods inherited from class org.apache.commons.math3.optim.BaseMultivariateOptimizer
`getLowerBound, getStartPoint, getUpperBound`

Methods inherited from class org.apache.commons.math3.optim.BaseOptimizer
`getConvergenceChecker, getIterations, getMaxEvaluations, getMaxIterations, incrementEvaluationCount, incrementIterationCount`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BaseMultiStartMultivariateOptimizer

    public BaseMultiStartMultivariateOptimizer(BaseMultivariateOptimizer<PAIR> optimizer,
                                               int starts,
                                               RandomVectorGenerator generator)

  Create a multi-start optimizer from a single-start optimizer.

  Parameters:
    `optimizer` - Single-start optimizer to wrap.
    `starts` - Number of starts to perform. If `starts == 1`, the `optimize` will return the same solution as the given `optimizer` would return.
    `generator` - Random vector generator to use for restarts.
  Throws:
    `NotStrictlyPositiveException` - if `starts < 1`.

Method Detail

### getEvaluations

    public int getEvaluations()

  Gets the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

  Overrides:
    `getEvaluations` in class `BaseOptimizer<PAIR>`
  Returns:
    the number of evaluations of the objective function.

### getOptima

    public abstract PAIR[] getOptima()

  Gets all the optima found during the last call to `optimize`. The optimizer stores all the optima found during a set of restarts. The `optimize` method returns the best point only. This method returns all the points found at the end of each starts, including the best one already returned by the `optimize` method.
  The returned array as one element for each start as specified in the constructor. It is ordered with the results from the runs that did converge first, sorted from best to worst objective value (i.e in ascending order if minimizing and in descending order if maximizing), followed by `null` elements corresponding to the runs that did not converge. This means all elements will be `null` if the `optimize` method did throw an exception. This also means that if the first element is not `null`, it is the best point found across all starts.
  The behaviour is undefined if this method is called before `optimize`; it will likely throw `NullPointerException`.

  Returns:
    an array containing the optima sorted from best to worst.

### optimize

    public PAIR optimize(OptimizationData... optData)

  Stores data and performs the optimization.
  The list of parameters is open-ended so that sub-classes can extend it with arguments specific to their concrete implementations.
  When the method is called multiple times, instance data is overwritten only when actually present in the list of arguments: when not specified, data set in a previous call is retained (and thus is optional in subsequent calls).

  Overrides:
    `optimize` in class `BaseMultivariateOptimizer<PAIR>`
  Parameters:
    `optData` - Optimization data. The following data will be looked for:
    - `MaxEval`
    - `InitialGuess`
    - `SimpleBounds`
  Returns:
    a point/value pair that satifies the convergence criteria.
  Throws:
    `MathIllegalStateException` - if `optData` does not contain an instance of `MaxEval` or `InitialGuess`.

### doOptimize

    protected PAIR doOptimize()

  Performs the bulk of the optimization algorithm.

  Specified by:
    `doOptimize` in class `BaseOptimizer<PAIR>`
  Returns:
    the point/value pair giving the optimal value of the objective function.

### store

    protected abstract void store(PAIR optimum)

  Method that will be called in order to store each found optimum.

  Parameters:
    `optimum` - Result of an optimization run.

### clear

    protected abstract void clear()

  Method that will called in order to clear all stored optima.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.